    Member
 Include('shpTime.inc'),Once

 Map
 End

eNoTime         EQUATE(0)
eMidnight       EQUATE(1)
eNoon           EQUATE(4320001)
eDay            EQUATE(8640000)
eEndOfAM        EQUATE(eNoon - eMidnight)
eEndOfPM        EQUATE(eDay) 
eTick		Equate(1)
eSecond 	Equate(100)
eMinute         Equate(6000)
eHour		Equate(360000)

shpTimeClass.Construct         PROCEDURE
    CODE

!============================ 

shpTimeClass.Destruct          PROCEDURE
    CODE

!============================ 

shpTimeClass.TimeRemaining     FUNCTION (Long pTimeOutTime)      ! Declare Procedure
ReturnString         STRING(20)
Hours                LONG
Minutes              LONG
Seconds              LONG
  CODE                                            ! Begin processed code
 If pTimeOutTime
   Hours = Self.CalcHours(Clock(),pTimeOutTime)
   Minutes = Self.CalcMinutes(Clock(),pTimeOutTime)
   Seconds = Self.CalcSeconds(Clock(),pTimeOutTime)
   If Hours
     ReturnString = Clip(Hours) & ':'
   End
   ReturnString = Clip(ReturnString) & Clip(Minutes) & ':' & Clip(Seconds)
 Else
   ReturnString = ''
 End
 Return(ReturnString)
 
 !============================ 

shpTimeClass.IsTimeUp             FUNCTION (Long pTimeOutTime)      ! Declare Procedure
  CODE                                            ! Begin processed code
 If pTimeOutTime > Clock() or ~pTimeOutTime
   Return(False)
 Else
   Return(True)
 End

!============================ 

shpTimeClass.CalcEndTime          FUNCTION (Real pTimeAllowed)      ! Declare Procedure
  CODE                                            ! Begin processed code
 Return( Clock() + (pTimeAllowed * 6000) )

!============================ 

shpTimeClass.CalcSeconds          FUNCTION (Long pBeginTime, Long pEndTime) ! Declare Procedure
ET                   LONG
EndTime              LONG
BeginTime            LONG
Hours                USHORT
MinSec               LONG
Minutes              BYTE
Secs                 LONG
Seconds              BYTE
Hundredths           LONG
TimeString           STRING(20)
LongTimeString       STRING(40)
  CODE                                            ! Begin processed code
 EndTime = pEndTime
 BeginTime = pBeginTime
 ET = (EndTime - 1) - (BeginTime - 1) + 1
 Hours = Int( ET / 360000 )
 MinSec = ET % 360000
 Minutes = Int( MinSec / 6000 )
 Secs = MinSec % 6000
 Seconds = Secs / 100
 If BeginTime
   Hundredths = Secs % 100
 Else
   Hundredths = 0
 End
 Return(Clip(Seconds) & '.' & Clip(Hundredths))

!============================ 

shpTimeClass.CalcMinutes          FUNCTION (Long pBeginTime, Long pEndTime) ! Declare Procedure
ET                   LONG
EndTime              LONG
BeginTime            LONG
Hours                USHORT
MinSec               LONG
Minutes              BYTE
Secs                 LONG
Seconds              BYTE
Hundredths           LONG
TimeString           STRING(20)
LongTimeString       STRING(40)
  CODE                                            ! Begin processed code
 EndTime = pEndTime
 BeginTime = pBeginTime
 ET = (EndTime - 1) - (BeginTime -1) + 1
 Hours = Int( ET / 360000 )
 MinSec = ET % 360000
 Minutes = Int( MinSec / 6000 )
 Return(Minutes)

!============================ 

shpTimeClass.CalcHours            FUNCTION (Long pBeginTime, Long pEndTime) ! Declare Procedure
ET                   LONG
EndTime              LONG
BeginTime            LONG
Hours                USHORT
MinSec               LONG
Minutes              BYTE
Secs                 LONG
Seconds              BYTE
Hundredths           LONG
TimeString           STRING(20)
LongTimeString       STRING(40)
  CODE                                            ! Begin processed code
 EndTime = pEndTime
 BeginTime = pBeginTime
 ET = (EndTime - 1) - (BeginTime -1) + 1
 Hours = Int( ET / 360000 )
 Return(Hours)

!============================ 

shpTimeClass.CalcET               FUNCTION (Long pBeginTime, Long pEndTime) ! Declare Procedure
ET                   LONG
EndTime              LONG
BeginTime            LONG
Hours                USHORT
MinSec               LONG
Minutes              BYTE
Secs                 LONG
Seconds              BYTE
Hundredths           LONG
TimeString           STRING(20)
LongTimeString       STRING(40)
  CODE                                            ! Begin processed code
 EndTime = pEndTime
 BeginTime = pBeginTime
 ET = (EndTime - 1) - (BeginTime -1) + 1
! If (ET >= eDay or ET < 0) 
!   !stop('midnight rollover ')
!   ET += eDay      ! assume one day
! End
 Hours = Int( ET / 360000 )
 MinSec = ET % 360000
 Minutes = Int( MinSec / 6000 )
 Secs = MinSec % 6000
 Seconds = Secs / 100
 If BeginTime
   Hundredths = Secs % 100
 Else
   Hundredths = 0
 End
 TimeString = Clip(Hours) & ':' & Clip(Minutes) & ':' & Clip(Seconds) & '.' & Clip(Hundredths)
 LongTimeString = Clip(Hours) & ' Hour(s) ' & Clip(Minutes) & ' minutes ' & Clip(Seconds) & '.' & Clip(Hundredths) & ' seconds'
 !Display
 Return(LongTimeString)

!============================ 
